import es, dnd, popuplib, spe, cmdlib, random, gamethread, math
from dnd import dnd
from spe import HookAction
from spe import HookType
from getviewplayer import getviewplayer

def load():
    spe.parseINI('dnd/subscripts/signatures/mysigs.ini')
    spe.parseTypesINI('dnd/subscripts/signatures/mytypes.ini')
    spe.detourFunction('Respawn', HookType.Pre, pre_spawn)
    
    cmdlib.registerClientCommand('!good', alignment, 'Cleric Ability - allows them to cast good spells')
    cmdlib.registerClientCommand('!evil', alignment, 'Cleric Ability - allows them to cast evil spells')
    cmdlib.registerSayCommand('!good', alignment, 'Cleric Ability - allows them to cast good spells')
    cmdlib.registerSayCommand('!evil', alignment, 'Cleric Ability - allows them to cast evil spells')
    cmdlib.registerClientCommand('!light', light, 'Cleric Spell - Heals allies or harms enemies')
    cmdlib.registerClientCommand('!bless', bless, 'Cleric Spell - Increases allies Saves')
    cmdlib.registerClientCommand('!doom', doom, 'Cleric Spell - Lowers enemies Saves')
    cmdlib.registerClientCommand('!moderate', moderate, 'Cleric Spell - Heals allies or harms enemies')
    cmdlib.registerClientCommand('!shield', shield, 'Cleric Spell - Allies take some of your damage')
    cmdlib.registerClientCommand('!deathknell', deathknell, '')
    cmdlib.registerClientCommand('!serious', serious, '')
    cmdlib.registerClientCommand('!contagion', contagion, '')
    cmdlib.registerClientCommand('!magiccircle', magiccircle, '')
    cmdlib.registerClientCommand('!restoration', restoration, '')
    cmdlib.registerClientCommand('!poison', poison, '')
    
    info = popuplib.create('Cleric Info')
    info.addline('Cleric Class Information:')
    info.addline('  !spells - Shows spell menu')
    info.addline('  !mana - Shows how much mana you have')
    info.addline('  !turn (Not yet implemented) - deals damage to undead')
    info.addline('  !good - Cast good spells')
    info.addline('  !evil - Cast evil spells')
    info.addline('-> 9. Main Menu')
    info.submenu(9, 'main_menu')
    
    spellsg = popuplib.create('good_spells')
    spellsg.addline('Cleric Good Spell Menu')
    spellsg.addline('  !light - Heals a nearby ally- 5 mana')
    spellsg.addline('  !bless - Allies gain a bonus to their saves - 5 mana')
    spellsg.addline('  Level 3: !moderate - heals - 10 mana')
    spellsg.addline('   !shield - Damage Reduction for allies')
    spellsg.addline('      shared between all - 15 mana')
    spellsg.addline('  Level 5: !serious - heals - 20 mana')
    spellsg.addline('    !magiccircle - Gives reduction to magic damage - 25 mana')
    spellsg.addline('      including Holy Sword')
    spellsg.addline('  Level 9: !restoration - 30 mana - Restores a friendly players')
    spellsg.addline('     stats and removes most buffs/debuffs')    
    
    spellse = popuplib.create('evil_spells')
    spellse.addline('Cleric Evil Spell Menu')
    spellse.addline('  !light - Damages a nearby enemy - 5 mana')
    spellse.addline('  !doom - Lowers enemies saves - 5 mana')
    spellse.addline('  Level 3: !moderate - Damages - 10 mana')
    spellse.addline('   !deathknell - Kills enemy below 10% health')
    spellse.addline('     Restores mana/HP if not resisted - 15 mana')
    spellse.addline('  Level 5: !serious - Damages - 20 mana')
    spellse.addline('  !contagion - Spreads diseases to enemies - 25 mana')
    spellse.addline('  Level 9: !poison - 30 + Your level mana - Cripples an enemies')
    spellse.addline('    health pool')
    
def unload():
    popuplib.delete('Cleric Info')
    popuplib.delete('good_spells')
    popuplib.delete('evil_spells')
    
    spe.undetourFunction('Respawn', HookType.Pre, pre_spawn)
    
    cmdlib.unregisterClientCommand('!good')
    cmdlib.unregisterClientCommand('!evil')
    cmdlib.unregisterSayCommand('!good')
    cmdlib.unregisterSayCommand('!evil')
    cmdlib.unregisterClientCommand('!light')
    cmdlib.unregisterClientCommand('!bless')
    cmdlib.unregisterClientCommand('!doom')
    cmdlib.unregisterClientCommand('!moderate')
    cmdlib.unregisterClientCommand('!shield')
    cmdlib.unregisterClientCommand('!deathknell')
    cmdlib.unregisterClientCommand('!serious')
    cmdlib.unregisterClientCommand('!contagion')
    cmdlib.unregisterClientCommand('!magiccircle')
    cmdlib.unregisterClientCommand('!poison')
    cmdlib.unregisterClientCommand('!restoration')
    
    
def isClass(userid):
    if dnd.Player(userid).getClass() == 'Cleric':
        return 1
    return 0
    
def alignment(userid, args):
    if isClass(userid):
        if not es.exists('%s_alignment'%userid):
            es.set('%s_alignment'%userid, 'good')
        if dnd.Player(userid).alive():
            dnd.dndTell(userid, 'You can only change alignment while dead. You are %s'%es.ServerVar('%s_alignment'%userid))
        else:
            if es.getargv(0) == '!good':
                es.set('%s_alignment'%userid, 'good')
                dnd.dndTell(userid, 'You are now a good Cleric')
            if es.getargv(0) == '!evil':
                es.set('%s_alignment'%userid, 'evil')
                dnd.dndTell(userid, 'You are now an evil Cleric')
                
def distance(user1, user2):
    x,y,z = es.getplayerlocation(user1)
    x1,y1,z1 = es.getplayerlocation(user2)
    return math.sqrt(math.pow((x-x1), 2) + math.pow((y-y1), 2) + math.pow((z-z1), 2))
                
def light(userid, args):
    if isClass(userid) and dnd.Player(userid).alive():
        if not dnd.Temp(userid).get('mana') >= 5:
            dnd.dndTell(userid, 'You do not have enough mana to use this spell')
        else:
            if dnd.Temp(userid).get('cool down'):
                dnd.dndTell(userid, 'You must wait to cast another spell')
            else:
                if es.ServerVar('%s_alignment'%userid) == 'good':
                    ally = getviewplayer.getplayerview(userid)
                    if ally:
                        if dnd.Temp(ally).get('health') > int(es.getplayerprop(ally, 'CBasePlayer.m_iHealth')):
                            dnd.Temp(userid).add('mana', -5)
                            dnd.Temp(userid).set('cool down', 1)    
                            gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                            amount = random.randint(1,8) + min(7, dnd.Player(userid).getLevel())
                            dnd.heal(ally, amount)
                            if ally != userid:
                                dnd.dndTell(ally, 'You were healed by %s for %s health'%(es.getplayername(userid), amount))
                            dnd.dndTell(userid, 'You healed %s for %s health'%(es.getplayername(ally), amount))
                        else:
                            dnd.dndTell(userid, 'They don\'t need healing')
                if es.ServerVar('%s_alignment'%userid) == 'evil':
                    enemy = getviewplayer.getplayerview(userid)
                    if enemy and es.getplayerteam(enemy) != es.getplayerteam(userid):
                        dnd.Temp(userid).add('mana', -5)
                        dnd.Temp(userid).set('cool down', 1)
                        gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                        amount = random.randint(1,8) + min(7, dnd.Player(userid).getLevel())
                        if dnd.save(enemy, 'Will', 15 + min(7, dnd.Player(userid).getLevel()/4)):
                            amount /= 2
                        dnd.damage(enemy, userid, amount, 'magic')
                        dnd.dndTell(enemy, 'You were injured for %s health'%(amount))
                        dnd.dndTell(userid, 'You injured %s for %s health'%(es.getplayername(enemy), amount))

def bless(userid, args):
    if isClass(userid) and dnd.Player(userid).alive() and es.ServerVar('round_end') != '1':
        if es.ServerVar('%s_alignment'%userid) == 'good':
            if not dnd.Temp(userid).get('mana') >= 5:
                dnd.dndTell(userid, 'You do not have enough mana to use this spell')
            else:
                if dnd.Temp(userid).get('cool down'):
                    dnd.dndTell(userid, 'You must wait to cast another spell')
                else:                
                    allies = []
                    for ally in es.getUseridList():
                        if dnd.Player(ally).alive() and es.getplayerteam(ally) == es.getplayerteam(userid) and distance(userid, ally) < 1001:                            
                            allies.append(ally)
                    if allies:
                        dnd.Temp(userid).add('mana', -5)
                        dnd.Temp(userid).set('cool down', 1)    
                        gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                        for ally in allies:
                            amount = 3 + min(dnd.Player(userid).getLevel(), 5)
                            for x in ['Fortitude', 'Will', 'Reflex']:
                                dnd.Temp(ally).add(x, amount)
                            dnd.dndTell(ally, 'Your saves were increased by %s from %s'%(amount, es.getplayername(userid)))
                    else:
                        dnd.dndTell(userid, 'There was no one to buff')
    
def doom(userid, args):
    if isClass(userid) and dnd.Player(userid).alive() and es.ServerVar('round_end') != '1':
        if es.ServerVar('%s_alignment'%userid) == 'evil':
            if not dnd.Temp(userid).get('mana') >= 5:
                dnd.dndTell(userid, 'You do not have enough mana to use this spell')
            else:
                if dnd.Temp(userid).get('cool down'):
                    dnd.dndTell(userid, 'You must wait to cast another spell')
                else:                
                    enemies = []
                    for enemy in es.getUseridList():
                        if dnd.Player(enemy).alive() and es.getplayerteam(enemy) != es.getplayerteam(userid) and distance(userid, enemy) < 1001:
                            enemies.append(enemy)
                    if enemies:
                        dnd.Temp(userid).add('mana', -5)
                        dnd.Temp(userid).set('cool down', 1)    
                        gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                        amount = 3 + min(dnd.Player(userid).getLevel(), 5)
                        msg = 'You lowered all these players\' saves: '
                        for enemy in enemies:                        
                            if dnd.save(enemy, 'Will', 15 + min(dnd.Player(userid).getLevel()/4, 5)):
                                pass
                            else:
                                for x in ['Fortitude', 'Will', 'Reflex']:
                                    dnd.Temp(enemy).add(x, -amount)
                                msg += '%s '%es.getplayername(enemy)
                                dnd.dndTell(enemy, 'Your saves were decreased by %s from %s'%(amount, es.getplayername(userid)))
                                dnd.dndTell(userid, msg)
                    else:
                        dnd.dndTell(userid, 'No enemies to debuff')
                        
def moderate(userid, args):
    if isClass(userid) and dnd.Player(userid).alive():
        if dnd.Player(userid).getLevel() > 2:
            if not dnd.Temp(userid).get('mana') >= 10:
                dnd.dndTell(userid, 'You do not have enough mana to use this spell')
            else:
                if dnd.Temp(userid).get('cool down'):
                    dnd.dndTell(userid, 'You must wait to cast another spell')
                else:
                    if es.ServerVar('%s_alignment'%userid) == 'good':
                        ally = getviewplayer.getplayerview(userid)
                        if ally:
                            if dnd.Temp(ally).get('health') > int(es.getplayerprop(ally, 'CBasePlayer.m_iHealth')):
                                dnd.Temp(userid).add('mana', -10)
                                dnd.Temp(userid).set('cool down', 1)    
                                gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                                amount = random.randint(1,8) + random.randint(1,8) + min(14, dnd.Player(userid).getLevel())
                                dnd.heal(ally, amount)
                                if ally != userid:
                                    dnd.dndTell(ally, 'You were healed by %s for %s health'%(es.getplayername(userid), amount))
                                dnd.dndTell(userid, 'You healed %s for %s health'%(es.getplayername(ally), amount))
                            else:
                                dnd.dndTell(userid, 'They don\'t need healing')
                    if es.ServerVar('%s_alignment'%userid) == 'evil':
                        enemy = getviewplayer.getplayerview(userid)
                        if enemy and es.getplayerteam(enemy) != es.getplayerteam(userid):
                            dnd.Temp(userid).add('mana', -10)
                            dnd.Temp(userid).set('cool down', 1)
                            gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                            amount = random.randint(1,8) + random.randint(1,8) + min(14, dnd.Player(userid).getLevel())
                            if dnd.save(enemy, 'Will', 16 + min(7, dnd.Player(userid).getLevel()/4)):
                                amount /= 2
                            dnd.damage(enemy, userid, amount, 'magic')
                            dnd.dndTell(enemy, 'You were injured for %s health'%(amount))
                            dnd.dndTell(userid, 'You injured %s for %s health'%(es.getplayername(enemy), amount))
                            
def shield(userid, args):
    if isClass(userid) and dnd.Player(userid).alive() and dnd.Player(userid).getLevel() > 2 and es.ServerVar('round_end') != '1':
        if es.ServerVar('%s_alignment'%userid) == 'good':
            if not dnd.Temp(userid).get('mana') >= 15:
                dnd.dndTell(userid, 'You do not have enough mana to use this spell')
            else:
                if dnd.Temp(userid).get('cool down'):
                    dnd.dndTell(userid, 'You must wait to cast another spell')
                else:
                    dnd.Temp(userid).add('mana', -15)
                    dnd.Temp(userid).set('cool down', 1)    
                    gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                    dnd.dndTell(userid, 'Your nearby team mates are sharing damage reduction')
                    shieldCheck(userid, [], 10)

def shieldCheck(userid, allies = [],time = 0):
    if dnd.Player(userid).alive() and time and es.ServerVar('round_ended') != '1':
        count = 0
        for ally in es.getUseridList():
            if dnd.Player(ally).alive() and es.getplayerteam(ally) == es.getplayerteam(userid) and distance(userid, ally) < 1001:  
                if ally not in allies:
                    allies.append(ally)
        for ally in allies:
            if not dnd.Player(ally).alive() or es.getplayerteam(ally) != es.getplayerteam(userid) or distance(userid, ally) > 1001:
                allies.remove(ally)
                count -= 1
            else:
                count += 1
        if count > 1:
            count = 100 / count
            for ally in allies:
                drbuff(ally, count)
        time -= 1
        
                
def drbuff(userid, amount):
    dnd.Temp(userid).add('damage reduction', amount)
    gamethread.delayedname(10, 'dndtick', dnd.Temp(userid).add, ('damage reduction', -amount))

def serious(userid, args):
    if isClass(userid) and dnd.Player(userid).alive():
        if dnd.Player(userid).getLevel() > 4:
            if not dnd.Temp(userid).get('mana') >= 20:
                dnd.dndTell(userid, 'You do not have enough mana to use this spell')
            else:
                if dnd.Temp(userid).get('cool down'):
                    dnd.dndTell(userid, 'You must wait to cast another spell')
                else:
                    if es.ServerVar('%s_alignment'%userid) == 'good':
                        ally = getviewplayer.getplayerview(userid)
                        if ally:
                            if dnd.Temp(ally).get('health') > int(es.getplayerprop(ally, 'CBasePlayer.m_iHealth')):
                                dnd.Temp(userid).add('mana', -20)
                                dnd.Temp(userid).set('cool down', 1)    
                                gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                                amount = random.randint(1,8) + random.randint(1,8) + random.randint(1,8) + min(17, dnd.Player(userid).getLevel())
                                dnd.heal(ally, amount)
                                if ally != userid:
                                    dnd.dndTell(ally, 'You were healed by %s for %s health'%(es.getplayername(userid), amount))
                                dnd.dndTell(userid, 'You healed %s for %s health'%(es.getplayername(ally), amount))
                            else:
                                dnd.dndTell(userid, 'They don\'t need healing')
                    if es.ServerVar('%s_alignment'%userid) == 'evil':
                        enemy = getviewplayer.getplayerview(userid)
                        if enemy and es.getplayerteam(enemy) != es.getplayerteam(userid):
                            dnd.Temp(userid).add('mana', -20)
                            dnd.Temp(userid).set('cool down', 1)
                            gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                            amount = random.randint(1,8) + random.randint(1,8) + random.randint(1,8) + min(17, dnd.Player(userid).getLevel())
                            if dnd.save(enemy, 'Will', 17 + min(7, dnd.Player(userid).getLevel()/4)):
                                amount /= 2
                            dnd.damage(enemy, userid, amount, 'magic')
                            dnd.dndTell(enemy, 'You were injured for %s health'%(amount))
                            dnd.dndTell(userid, 'You injured %s for %s health'%(es.getplayername(enemy), amount))
    
def deathknell(userid, args):
    if isClass(userid) and dnd.Player(userid).alive() and dnd.Player(userid).getLevel() >= 3:
        if dnd.Player(userid).getLevel() > 2:
            if not dnd.Temp(userid).get('mana') >= 15:
                dnd.dndTell(userid, 'You do not have enough mana to use this spell')
            else:
                if dnd.Temp(userid).get('cool down'):
                    dnd.dndTell(userid, 'You must wait to cast another spell')
                else:
                    if es.ServerVar('%s_alignment'%userid) == 'evil':
                       enemy = getviewplayer.getplayerview(userid)
                       if enemy and es.getplayerteam(enemy) != es.getplayerteam(userid):
                            if dnd.Temp(enemy).get('health') / int(es.getplayerprop(enemy, 'CBasePlayer.m_iHealth')) >= 10:                                    
                                dnd.Temp(userid).add('mana', -15)
                                dnd.Temp(userid).set('cool down', 1)    
                                gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                                if dnd.save(enemy, 'Will', 16 + min(7, dnd.Player(userid).getLevel()/4)):
                                    dnd.dndTell(userid, 'Your target resisted your spell')
                                else:
                                    health = int(es.getplayerprop(enemy, 'CBasePlayer.m_iHealth'))
                                    dnd.damage(enemy, userid, 100, 'magic')
                                    dnd.dndTell(enemy, 'You were slain by %s'%es.getplayername(userid))
                                    dnd.dndTell(userid, 'You slew %s and gained %s health and mana'%(es.getplayername(enemy), health))
                                    dnd.heal(userid, health)
                                    dnd.Temp(userid).add('mana', int(health))
                                
def debuff(userid, amount):
    dnd.Temp(userid).add('debuff', amount)
    
def contagion(userid,args):
    if isClass(userid) and dnd.Player(userid).alive() and dnd.Player(userid).getLevel() >= 5 and es.ServerVar('round_end') != '1':
        if not dnd.Temp(userid).get('mana') >= 25:
            dnd.dndTell(userid, 'You do not have enough mana to use this spell')
        else:
            if dnd.Temp(userid).get('cool down'):
                dnd.dndTell(userid, 'You must wait to cast another spell')
            else:
                if es.ServerVar('%s_alignment'%userid) == 'evil':
                    enemies = []
                    for enemy in es.getUseridList():
                        if dnd.Player(enemy).alive() and es.getplayerteam(enemy) != es.getplayerteam(userid) and distance(userid, enemy) < 1001:
                            enemies.append(enemy)
                    if not enemies:
                        dnd.dndTell(userid, 'No one to cast on')
                    else:
                        dnd.Temp(userid).add('mana', -25)
                        dnd.Temp(userid).set('cool down', 1)    
                        gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                        for enemy in enemies:
                            if dnd.save(enemy, 'Fortitude', 17 + min(7, dnd.Player(userid).getLevel()/4)):
                                dnd.dndTell(userid, 'Your target resisted your spell')
                            else:
                                if dnd.Temp(enemy).get('mana'):
                                    dnd.Temp(enemy).add('mana', -dnd.Player(userid).getLevel() * 2)
                                    dnd.dndTell(enemy, 'You were infected with Mind Fire')
                                    dnd.dndTell(userid, 'You infected %s with Mind Fire and he has lowered Intelligence, Wisdom, and Charisma'%es.getplayername(enemy))
                                elif dnd.Temp(enemy).get('stealth') < 200:
                                    dnd.Temp(enemy).add('stealth', -dnd.Player(userid).getLevel() * 3)
                                    dnd.dndTell(enemy, 'You were infected with The Shakes')
                                    dnd.dndTell(userid, 'You infected %s with The Shakes and he has lowered Dexterity'%es.getplayername(enemy))
                                elif dnd.Temp(enemy).get('health') > 100:
                                    dnd.regen(enemy, 4, -5, 10)
                                    for x in range(4,20,4):
                                        gamethread.delayedname(x, 'dndtick', dnd.Temp(enemy).add, ('health', dnd.Temp(userid).get('health') - dnd.Player(userid).getLevel() * 1.5))
                                    dnd.dndTell(enemy, 'You were infected with Slimy Doom')
                                    dnd.dndTell(userid, 'You infected %s with Slimy Doom and he has a lowered Constitution'%es.getplayername(enemy))
                                else:
                                    debuff(enemy, dnd.Player(userid).getLevel())
                                    dnd.dndTell(enemy, 'You were infected with Red Ache')
                                    dnd.dndTell(userid, 'You infected %s with Red Ache and he has lowered Strength'%es.getplayername(enemy))
                                    
def magiccircle(userid, args):
    if isClass(userid) and dnd.Player(userid).alive() and dnd.Player(userid).getLevel() > 4 and es.ServerVar('round_end') != '1':
        if es.ServerVar('%s_alignment'%userid) == 'good':
            if not dnd.Temp(userid).get('mana') >= 25:
                dnd.dndTell(userid, 'You do not have enough mana to use this spell')
            else:
                if dnd.Temp(userid).get('cool down'):
                    dnd.dndTell(userid, 'You must wait to cast another spell')
                else:
                    dnd.Temp(userid).add('mana', -25)
                    dnd.Temp(userid).set('cool down', 1)    
                    gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                    dnd.dndTell(userid, 'Your neraby team mates are in a Circle of Protection')
                    for ally in es.getUseridList():
                        if dnd.Player(ally).alive() and es.getplayerteam(ally) == es.getplayerteam(userid) and distance(userid, ally) < 1001:  
                            dnd.Temp(ally).add('magic reduction', min(dnd.Player(userid).getLevel() * 5, 50))
                            
def restoration(userid, args):
    if isClass(userid) and dnd.Player(userid).alive() and dnd.Player(userid).getLevel() > 8 and es.ServerVar('round_end') != '1':
        if es.ServerVar('%s_alignment'%userid) == 'good':
            if not dnd.Temp(userid).get('mana') >= 30:
                dnd.dndTell(userid, 'You do not have enough mana to use this spell')
            else:
                x = popuplib.easymenu('resto_menu_%s'%userid, '_popup_choice', restoChoice)
                x.settitle('Select a player to Restore:')
                for ally in es.getUseridList():
                    if dnd.Player(ally).alive() and int(es.getplayerteam(ally)) == int(es.getplayerteam(userid)):
                        x.addoption(ally, '%s - %s HP'%(es.getplayername(ally), es.getplayerprop(ally, 'CBasePlayer.m_iHealth')))
                x.send(userid)
                    
def restoChoice(userid, choice, popupid):
    if isClass(userid) and dnd.Player(userid).alive() and dnd.Player(userid).getLevel() > 8 and es.ServerVar('round_end') != '1':
        if es.ServerVar('%s_alignment'%userid) == 'good':
            if not dnd.Temp(userid).get('mana') >= 30:
                dnd.dndTell(userid, 'You do not have enough mana to use this spell')
            else:
                if dnd.Temp(userid).get('cool down'):
                    dnd.dndTell(userid, 'You must wait to cast another spell')
                else:
                    if dnd.Player(choice).alive() and int(es.getplayerteam(choice)) == int(es.getplayerteam(userid)):
                        dnd.Temp(userid).add('mana', -25)
                        dnd.Temp(userid).set('cool down', 1)    
                        gamethread.delayedname(1.5, 'dndtick', dnd.cooldownoff, userid)
                        health = float(es.getplayerprop(choice, 'CBasePlayer.m_iHealth')) / float(dnd.Temp(choice).get('health'))
                        x,y,z = es.getplayerlocation(choice)
                        spe.respawn(choice)
                        es.setplayerprop(choice, 'CBasePlayer.m_iHealth', float(dnd.Temp(choice).get('health')) * health)
                        es.setpos(choice, x, y, z)
                        if choice != userid:
                            dnd.dndTell(choice, 'A friendly Cleric restored you!')
                        dnd.dndTell(userid, 'You have restored %s'%es.getplayername(choice))
                        
def poison(userid, args):
    if isClass(userid) and dnd.Player(userid).alive() and dnd.Player(userid).getLevel() >= 9 and es.ServerVar('round_end') != '1':
        if not dnd.Temp(userid).get('mana') >= 30 + dnd.Player(userid).getLevel():
            dnd.dndTell(userid, 'You do not have enough mana to use this spell')
        else:
            if dnd.Temp(userid).get('cool down'):
                dnd.dndTell(userid, 'You must wait to cast another spell')
            else:
                if es.ServerVar('%s_alignment'%userid) == 'evil':
                    if not dnd.Temp(userid).get('poison spell'):
                        dnd.Temp(userid).add('poison spell', 1)
                        dnd.Temp(userid).add('mana', -30 - dnd.Player(userid).getLevel())
                        dnd.dndTell(userid, 'Your next attack will cast Poison on the enemy, crippling their constitution')
                    else:
                        dnd.dndTell(userid, 'Your next attack will already cast Poison on the enemy')
    
                                  
def pre_spawn(args):
    userid = es.getuserid(es.gethandlefromindex(spe.getEntityIndex(args[0])))
    if isClass(userid):
        dnd.Temp(userid).add('Fortitude', dnd.Player(userid).getLevel()/2+2)
        dnd.Temp(userid).add('Reflex', dnd.Player(userid).getLevel()/3)
        dnd.Temp(userid).add('Will', dnd.Player(userid).getLevel()/2+2)
        dnd.Temp(userid).set('cool down', 0)
        dnd.Temp(userid).add('mana', dnd.Player(userid).getLevel() * 10)
        if es.ServerVar('%s_alignment'%(userid)) != 'good' and es.ServerVar('%s_alignment'%(userid)) != 'evil':
            dnd.dndTell(userid, 'Defaulting to good')
            es.set('%s_alignment'%userid, 'good')        
    return (HookAction.Continue, 0)
        

            