import es, dnd, random, spe, gamethread, math
from dnd import dnd
from spe import HookAction
from spe import HookType

from spe.tools.player import SPEPlayer
from spe.tools.weapon import SPEWeapon

def load():
    spe.parseINI('dnd/subscripts/signatures/mysigs.ini')
    spe.parseTypesINI('dnd/subscripts/signatures/mytypes.ini')
    spe.detourFunction('OnTakeDamage', HookType.Pre, pre_hurt)
    
def unload():
    spe.undetourFunction('OnTakeDamage', HookType.Pre, pre_hurt)
    
def getClass(userid):
    return dnd.Player(userid).getClass()

def pre_hurt(args):
    # Get the takedamage instance.
    takeDamageInfo = spe.makeObject('CTakeDamageInfo', args[0])
    
    attacker = es.getuserid(takeDamageInfo.hAttacker)
    victim = es.getuserid(es.gethandlefromindex(spe.getEntityIndex(args[1])))
    damage = int(takeDamageInfo.flDamage)
    
    if getClass(victim) == 'Rogue':
        dnd.unstealth(victim, 4)
        if victim.get('dodge percent') >= random.randint(1, 100):
            if dnd.Player(victim).alive():
                damage = 0
                dnd.dndTell(ev['userid'], 'You have dodged an attack!')
                dnd.dndTell(ev['attacker'], 'Your attack was dodged!')
                return (HookAction.Override, 0)
        
    crit = random.randint(1,100) + dnd.Temp(attacker).get('critical chance')
    if 95 - crit <= 0:
        damage *= 2
        dnd.dndTell(attacker, 'You crit your target!')
    
    if getClass(attacker) == 'Cleric' and dnd.Temp(attacker).get('poison spell') > 0:
        poisonPlayer(victim, attacker)
        dnd.Temp(attacker).add('poison spell', -1)
        
    if getClass(attacker) == 'Sorceror' and dnd.Temp(attacker).get('death knell') > 0:
        if takeDamageInfo.hAttacker == takeDamageInfo.hInflictor:                
            userid = es.getuserid(takeDamageInfo.hAttacker)
            spe_player = SPEPlayer(userid)
            weapon_h = spe_player.active_weapon
            index = es.getindexfromhandle(weapon_h)
        else:
            index = es.getindexfromhandle(takeDamageInfo.hInflictor)
        weapon = SPEWeapon(index)
        if weapon.classname.replace('weapon_','') in ['knife']:
            dnd.Temp(attacker).add('death knell', -1)
            if dnd.save(userid, 'Fortitude', 18 + dnd.Player(attacker).getLevel() / 5):
                dnd.dndTell(attacker, 'They resisted your death knell')
            else:
                dnd.dndTell(attacker, 'You used Finger of Death!')
                damage += 1000
                
        
    if getClass(attacker) == 'Figher':        
        if attacker.Team != victim.Team and int(attacker) > 0:
            # Power Attack
            if dnd.Temp(attacker).get('power attack'):
                chance = random.randint(1,100)
                if chance < 35 - attacker.getLevel():
                    dnd.dndTell(attacker, 'Your attack missed!')
                    dnd.Temp(attacker).set('power attack', 0)
                    damage = 0
                if chance > 90 - attacker.getLevel():
                    damage += damage * .5
                    dnd.dndTell(attacker, 'Your attack did an extra %s damage from Power Attack!'%int(damage * .5))
                    dnd.Temp(attacker).set('power attack', 0)
                if chance >= 35 and chance <= 90:
                    dnd.dndTell(attacker, 'Your attack did normal damage')
                    dnd.Temp(attacker).set('power attack', 0)
            # Dual Wielding
            if attacker.getLevel() >= 3:
                if takeDamageInfo.hAttacker == takeDamageInfo.hInflictor:                
                    userid = es.getuserid(takeDamageInfo.hAttacker)
                    spe_player = SPEPlayer(userid)
                    weapon_h = spe_player.active_weapon
                    index = es.getindexfromhandle(weapon_h)
                else:
                    index = es.getindexfromhandle(takeDamageInfo.hInflictor)
                weapon = SPEWeapon(index)
                if weapon.classname.replace('weapon_','') in ['mp5navy', 'tmp', 'mac10', 'p90', 'ump45', 'elite']:
                    chance = random.randint(1,100)
                    if chance < 10:
                        damage = 0
                        dnd.dndTell(attacker, 'Your attacks missed')
                    if chance > 90 - attacker.getLevel():
                        dnd.dndTell(attacker, 'Your off-hand attack hit for %s damage!'%takeDamageInfo.flDamage)
                        crit = random.randint(1,100) + dnd.Temp(attacker).get('critical chance')
                        if 95 - crit >= 0:
                            damage = damage * 3
                        else:
                            damage += damage
            # Weapon Specialization
            if attacker.getLevel() >= 5:
                damage += damage * .03 * attacker.getLevel()
                

            if dnd.Temp(attacker).get('whirlwind'):
                userid = 0
                for userid in es.getUseridList():
                    if dnd.Player(userid).alive() and es.getplayerteam(userid) != es.getplayerteam(ev['attacker']):
                        x,y,z = es.getplayerlocation(userid)
                        x1,y1,z1 = es.getplayerlocation(victim)
                        x2,y2,z2 = es.getplayerlocation(attacker)
                        distance = math.sqrt(math.pow((x-x1), 2) + math.pow((y-y1), 2) + math.pow((z-z1), 2))
                        distance2 = math.sqrt(math.pow((x2-x1), 2) + math.pow((y2-y1), 2) + math.pow((z2-z1), 2))
                        if distance <= 800:
                            if userid != victim:
                                dnd.damage(victim, attacker, min(damage, damage * (600/distance2)), 'physical')
                                dnd.dndTell(attacker, 'You dealt %s damage to %s with Whirl Wind!'%(int(min(damage, damage * (600/distance2))), es.getplayername(userid)))
                                
            if dnd.Player(attacker).getLevel() >= 20:
                if takeDamageInfo.bitsDamageType & 1<<30:
                    damage *= 2
                                
    if getClass(attacker) == "Paladin":
        if dnd.Player(attacker).getLevel() >= 9:
            damage = 0
            dnd.damage(userid, attacker, damage,'magic')
            
    if getClass(attacker) == 'Rogue':
        if dnd.Player(attacker).getLevel() >= 2:
            if dnd.Temp(attacker).get('stealthed'):
                sneakDamage = 0
                sneakDice = dnd.Player(attacker).getLevel() / 2
                while sneakDice:
                    sneakDamage += random.randint(1,6)
                    sneakDice -= 1
                damage += sneakDamage
                dnd.dndTell(attacker, 'You did %s sneak attack damage!'%sneakDamage)
        if dnd.Player(attacker).getLevel() >= 7 and dnd.Temp(userid).get('last attacked') != int(attacker):
            damage += damage / (6 + (2/3))
            dnd.dndTell(attacker, 'You did an extra %s damage with Combat Reflexes'%(damage/(6 + (2/3))))
        dnd.unstealth(attacker, 4)
        if dnd.Player(attacker).getLevel() >= 17:
            if not dnd.save(victim, 'Fortitude', 22):
                dnd.stun(victim, 1)
        if dnd.Player(attacker).getLevel() >= 20:
            x,y,z = es.getplayermovement(attacker)
            if int(x) == 0 and int(y) == 0 and int(z) == 0:
                damage *= 1.2
            
    if getClass(victim) == "Paladin":
        if dnd.Temp(victim).get('Lay On Hands'):
            health = int(es.getplayerprop(victim, 'CBasePlayer.m_iHealth'))
            if int(dnd.Temp(victim).get('health')) / health >= 5:
                dnd.Temp(victim).add('Lay On Hands', -1)
                dnd.heal(victim, min(dnd.Player(victim).getLevel() * 10, 50))
                dnd.dndTell(victim, 'Your Lay On Hands has healed you for %s Health'%min(dnd.Player(victim).getLevel() * 10, 50))
        if dnd.Player(victim).getLevel() >= 19:
            if random.randint(1,10) == 1:
                es.setplayerprop(victim, "CCSPlayer.m_flFlashMaxAlpha", 0)
                es.setplayerprop(victim, "CCSPlayer.m_flFlashDuration", 0)
                # Set new value
                es.setplayerprop(victim, "CCSPlayer.m_flFlashMaxAlpha", 255)
                es.setplayerprop(victim, "CCSPlayer.m_flFlashDuration", 2)
        '''
        if dnd.Player(victim).getLevel() >= 3:
            if int(es.getplayerprop(self.userid, "CCSPlayer.m_ArmorValue")):
                damage = damage - (float(es.getplayerprop(self.userid, "CCSPlayer.m_ArmorValue")) / 2 / 100)
        '''
        if dnd.Player(victim).getLevel() >= 15:
            if takeDamageInfo.hAttacker == takeDamageInfo.hInflictor:                
                userid = es.getuserid(takeDamageInfo.hAttacker)
                spe_player = SPEPlayer(userid)
                weapon_h = spe_player.active_weapon
                index = es.getindexfromhandle(weapon_h)
            else:
                index = es.getindexfromhandle(takeDamageInfo.hInflictor)
            weapon = SPEWeapon(index)
            if weapon.classname.replace('weapon_','') == 'knife':
                damage = damage/5
                    
    if dnd.Temp(victim).get('damage reduction'):
        es.msg('Damage - %s | Damage Reduction - %s'%(damage, dnd.Temp(victim).get('damage reduction')))
        damage = damage - (damage * dnd.Temp(victim).get('damage reduction') * .01)
        es.msg('Modified damage')
                    
    if dnd.Player(attacker).getRace() == 'Kobold':
        damage = damage - damage * .1
        
    if dnd.Player(attacker).getRace() == 'Halfling':
        damage = damage - damage * .1
        
    if dnd.Player(attacker).getRace() == 'GreyElf':
        damage = damage - damage * .05
        
    if dnd.Player(attacker).getRace == 'Orc':
        damage = damage + damage * .1
        
    takeDamageInfo.flDamage = damage
    # Let the function continue executing.
    return (HookAction.Continue, 0)
    
def player_hurt(ev):
    dnd.Temp(ev['attacker']).set('last attacked', int(ev['userid']))
    dnd.Temp(ev['userid']).set('last attacker', int(ev['attacker']))
    
    attacker = dnd.Player(ev['attacker'])
    
    if attacker.getRace() == "Kobold":
        if ev['weapon'] == 'hegrenade':
            dnd.burn(ev['userid'], 4)
    
    if es.getplayerprop(ev['userid'], 'CBasePlayer.pl.deadflag'):
        if attacker.getClass() == 'Fighter' and attacker.getLevel() > 8:
            for player in es.getUseridList():
                if es.getplayerteam(player) != es.getplayerteam(ev['attacker']) and distance(player, ev['attacker']) < 600 and not es.getplayerprop(player, 'CBasePlayer.pl.deadflag'):
                    dnd.damage(player, ev['attacker'], int(ev['dmg_health']), type='physical')
                    dnd.dndTell(ev['attacker'], 'You cleaved %s for %s damage!'%(es.getplayername(player), ev['dmg_health']))
                    dnd.dndTell(player, 'You were cleaved!')
    
def poisonPlayer(userid, attacker, loops=2):
    if dnd.Player(userid).alive():
        loops -= 1
        if dnd.save(userid, 'Fortitude', 18 + dnd.Player(attacker).getLevel() / 5):
            if loops == 1:
                dnd.dndTell(attacker, 'Your target resisted the first poisoning')
            if loops == 0:
                dnd.dndTell(attacker, 'Your target resisted the second poisoning')
                return 0
        else:
            if loops == 1:
                defecit = -10 * random.randrange(1,dnd.Player(attacker).getLevel()/4)
                dnd.Temp(userid).add('health', defecit)
                dnd.regen(userid, 1, 0)
                dnd.dndTell(userid, 'You were poisoned!')
                dnd.dndTell(attacker, 'Your target was affected by the first poisoning')
            if loops == 0:
                defecit = -10 * random.randrange(1,dnd.Player(attacker).getLevel()/4)
                dnd.Temp(userid).add('health', defecit)
                dnd.regen(userid, 1, 0)
                dnd.dndTell(userid, 'You were poisoned!')
                dnd.dndTell(attacker, 'Your target was affected by the second poisoning')
        if loops:
            gamethread.delayedname(5, 'dndtick', poisonPlayer, (userid, attacker, 1))
            
def distance(user1, user2):
    x,y,z = es.getplayerlocation(user1)
    x1,y1,z1 = es.getplayerlocation(user2)
    return math.sqrt(math.pow((x-x1), 2) + math.pow((y-y1), 2) + math.pow((z-z1), 2))
    
    